#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SIZE_OF_ARRAY       24u

unsigned int source[SIZE_OF_ARRAY];
unsigned int dest[SIZE_OF_ARRAY];
int loopCounter = 0;

void BubbleSort(unsigned int* s, unsigned int size)
{
    unsigned int i,j,temp;
    loopCounter = 0;
    for(i=1; i<size; i++) {
        for(j=0; j<(size-i); j++) {
            if(s[j] > s[j+1])
            {
                temp       = s[j];
                s[j]   = s[j+1];
                s[j+1] = temp;
            }
            loopCounter++;
        }
    }
    printf("\nExecuted loop %d times to sort %d entries.", loopCounter, size);
}

int main()
{
    unsigned int i;

    printf("Filling array with random numbers between 0 and 99:\n");
    for(i=0; i<SIZE_OF_ARRAY; i++) {
        source[i] = rand() / (RAND_MAX / 100);
        printf("%d ",source[i]);
    }

    BubbleSort(source, SIZE_OF_ARRAY);
    memcpy(dest, source, sizeof(unsigned int) * SIZE_OF_ARRAY);

    printf("\n\nOutput array after sorting:\n");
    for(i=0; i<SIZE_OF_ARRAY; i++) {
        printf("%d ",dest[i]);
    }
    printf("\n");
    return 0;
}